diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/compat/linux/linux_misc.c head/sys/compat/linux/linux_misc.c
--- clean-head/sys/compat/linux/linux_misc.c	2013-06-26 09:39:20.000000000 +0200
+++ head/sys/compat/linux/linux_misc.c	2013-06-24 14:21:32.000000000 +0200
@@ -67,6 +67,8 @@ __FBSDID("$FreeBSD: head/sys/compat/linu
 #include <sys/wait.h>
 #include <sys/cpuset.h>
 
+#include <vps/vps.h>
+
 #include <security/mac/mac_framework.h>
 
 #include <vm/vm.h>
@@ -165,7 +167,7 @@ linux_sysinfo(struct thread *td, struct 
 	sysinfo.totalswap = i * PAGE_SIZE;
 	sysinfo.freeswap = (i - j) * PAGE_SIZE;
 
-	sysinfo.procs = nprocs;
+	sysinfo.procs = V_nprocs;
 
 	/* The following are only present in newer Linux kernels. */
 	sysinfo.totalbig = 0;
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/compat/svr4/svr4_misc.c head/sys/compat/svr4/svr4_misc.c
--- clean-head/sys/compat/svr4/svr4_misc.c	2013-06-26 09:39:16.000000000 +0200
+++ head/sys/compat/svr4/svr4_misc.c	2013-06-24 14:21:33.000000000 +0200
@@ -68,6 +68,8 @@ __FBSDID("$FreeBSD: head/sys/compat/svr4
 #include <sys/vnode.h>
 #include <sys/wait.h>
 
+#include <vps/vps.h>
+
 #include <compat/svr4/svr4.h>
 #include <compat/svr4/svr4_types.h>
 #include <compat/svr4/svr4_signal.h>
@@ -738,7 +740,7 @@ svr4_sys_sysconfig(td, uap)
 		*retval = 0;	/* No delaytimer support */
 		break;
 	case SVR4_CONFIG_MQ_OPEN_MAX:
-		*retval = msginfo.msgmni;
+		*retval = V_msginfo.msgmni;
 		break;
 	case SVR4_CONFIG_MQ_PRIO_MAX:
 		*retval = 0;	/* XXX: Don't know */
@@ -747,10 +749,10 @@ svr4_sys_sysconfig(td, uap)
 		*retval = 0;
 		break;
 	case SVR4_CONFIG_SEM_NSEMS_MAX:
-		*retval = seminfo.semmni;
+		*retval = V_seminfo.semmni;
 		break;
 	case SVR4_CONFIG_SEM_VALUE_MAX:
-		*retval = seminfo.semvmx;
+		*retval = V_seminfo.semvmx;
 		break;
 	case SVR4_CONFIG_SIGQUEUE_MAX:
 		*retval = 0;	/* XXX: Don't know */
@@ -1236,7 +1238,7 @@ svr4_sys_waitsys(td, uap)
 	 */
 loop:
 	nfound = 0;
-	sx_slock(&proctree_lock);
+	sx_slock(&V_proctree_lock);
 	LIST_FOREACH(p, &q->p_children, p_sibling) {
 		PROC_LOCK(p);
 		if (pid != WAIT_ANY &&
@@ -1272,7 +1274,7 @@ loop:
 			calcru(p, &ru.ru_utime, &ru.ru_stime);
 			PROC_SUNLOCK(p);
 			PROC_UNLOCK(p);
-			sx_sunlock(&proctree_lock);
+			sx_sunlock(&V_proctree_lock);
 
 			/* Copy the info out to userland. */
 			*retval = 0;
@@ -1291,7 +1293,7 @@ loop:
 			PROC_SUNLOCK(p);
 		        if (((uap->options & SVR4_WNOWAIT)) == 0)
 				p->p_flag |= P_WAITED;
-			sx_sunlock(&proctree_lock);
+			sx_sunlock(&V_proctree_lock);
 			pid = p->p_pid;
 			status = W_STOPCODE(p->p_xstat);
 			ru = p->p_ru;
@@ -1313,7 +1315,7 @@ loop:
 		PROC_SUNLOCK(p);
 		if (uap->options & SVR4_WCONTINUED &&
 		    (p->p_flag & P_CONTINUED)) {
-			sx_sunlock(&proctree_lock);
+			sx_sunlock(&V_proctree_lock);
 		        if (((uap->options & SVR4_WNOWAIT)) == 0)
 				p->p_flag &= ~P_CONTINUED;
 			pid = p->p_pid;
@@ -1338,18 +1340,18 @@ loop:
 	}
 
 	if (nfound == 0) {
-		sx_sunlock(&proctree_lock);
+		sx_sunlock(&V_proctree_lock);
 		return (ECHILD);
 	}
 
 	if (uap->options & SVR4_WNOHANG) {
-		sx_sunlock(&proctree_lock);
+		sx_sunlock(&V_proctree_lock);
 		*retval = 0;
 		return (svr4_setinfo(0, NULL, 0, uap->info));
 	}
 
 	PROC_LOCK(q);
-	sx_sunlock(&proctree_lock);
+	sx_sunlock(&V_proctree_lock);
 	if (q->p_flag & P_STATCHILD) {
 		q->p_flag &= ~P_STATCHILD;
 		error = 0;
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/conf/files head/sys/conf/files
--- clean-head/sys/conf/files	2013-06-26 09:37:34.000000000 +0200
+++ head/sys/conf/files	2013-06-24 14:20:29.000000000 +0200
@@ -4,6 +4,7 @@
 # limitations in config: backslash-newline doesn't work in strings, and
 # dependency lines other than the first are silently ignored.
 #
+
 acpi_quirks.h			optional acpi				   \
 	dependency	"$S/tools/acpi_quirks2h.awk $S/dev/acpica/acpi_quirks" \
 	compile-with	"${AWK} -f $S/tools/acpi_quirks2h.awk $S/dev/acpica/acpi_quirks" \
@@ -3706,6 +3707,32 @@ vm/vm_reserv.c			standard
 vm/vm_unix.c			standard
 vm/vm_zeroidle.c		standard
 vm/vnode_pager.c		standard
+#
+vps/vps_core.c			optional vps
+vps/vps_priv.c			optional vps
+vps/vps_console.c		optional vps
+vps/vps_pager.c			optional vps
+#
+vps/vps_account.c		optional vps_static
+#
+vps/vps_suspend.c		optional vps_static
+#
+vps/vps_dev.c			optional vps_static
+vps/vps_user.c			optional vps_static
+#
+vps/if_vps.c			optional vps_static
+#
+vps/vps_snapst.c		optional vps_static
+vps/vps_restore.c		optional vps_static
+vps/vps_libdump.c		optional vps_static
+#
+vps/vps_ddb.c			optional vps_static
+#
+fs/vpsfs/vpsfs_subr.c		optional vps_static
+fs/vpsfs/vpsfs_vfsops.c		optional vps_static
+fs/vpsfs/vpsfs_vnops.c		optional vps_static
+fs/vpsfs/vpsfs_quota.c		optional vps_static
+#
 xen/gnttab.c			optional xen | xenhvm
 xen/features.c			optional xen | xenhvm
 xen/evtchn/evtchn.c		optional xen
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/conf/files.amd64 head/sys/conf/files.amd64
--- clean-head/sys/conf/files.amd64	2013-06-26 09:37:34.000000000 +0200
+++ head/sys/conf/files.amd64	2013-06-24 14:20:29.000000000 +0200
@@ -129,6 +129,7 @@ amd64/amd64/trap.c		standard
 amd64/amd64/uio_machdep.c	standard
 amd64/amd64/uma_machdep.c	standard
 amd64/amd64/vm_machdep.c	standard
+amd64/amd64/vps_machdep.c	optional	vps
 amd64/pci/pci_cfgreg.c		optional	pci
 cddl/contrib/opensolaris/common/atomic/amd64/opensolaris_atomic.S	optional zfs compile-with "${ZFS_S}"
 crypto/aesni/aesencdec_amd64.S	optional aesni
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/conf/files.i386 head/sys/conf/files.i386
--- clean-head/sys/conf/files.i386	2013-06-26 09:37:34.000000000 +0200
+++ head/sys/conf/files.i386	2013-06-24 14:20:29.000000000 +0200
@@ -452,6 +452,7 @@ i386/i386/trap.c		standard
 i386/i386/uio_machdep.c		standard
 i386/i386/vm86.c		standard
 i386/i386/vm_machdep.c		standard
+i386/i386/vps_machdep.c		optional vps
 i386/ibcs2/ibcs2_errno.c	optional ibcs2
 i386/ibcs2/ibcs2_fcntl.c	optional ibcs2
 i386/ibcs2/ibcs2_ioctl.c	optional ibcs2
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/conf/files.mips head/sys/conf/files.mips
--- clean-head/sys/conf/files.mips	2013-06-26 09:37:34.000000000 +0200
+++ head/sys/conf/files.mips	2013-06-24 14:20:29.000000000 +0200
@@ -45,6 +45,7 @@ mips/mips/trap.c			standard
 mips/mips/uio_machdep.c			standard
 mips/mips/uma_machdep.c			standard
 mips/mips/vm_machdep.c			standard
+mips/mips/vps_machdep.c			optional	vps
 
 # misc opt-in bits
 kern/kern_clocksource.c			standard
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/conf/options head/sys/conf/options
--- clean-head/sys/conf/options	2013-06-26 09:37:34.000000000 +0200
+++ head/sys/conf/options	2013-06-24 14:20:29.000000000 +0200
@@ -877,6 +877,9 @@ SND_FEEDER_RATE_HP	opt_snd.h
 SND_PCM_64		opt_snd.h
 SND_OLDSTEREO		opt_snd.h
 
+VPS			opt_global.h
+VPS_STATIC		opt_global.h
+
 X86BIOS
 
 # Flattened device tree options
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/ddb/db_command.c head/sys/ddb/db_command.c
--- clean-head/sys/ddb/db_command.c	2013-06-26 09:37:39.000000000 +0200
+++ head/sys/ddb/db_command.c	2013-06-24 14:21:40.000000000 +0200
@@ -56,6 +56,8 @@ __FBSDID("$FreeBSD: head/sys/ddb/db_comm
 #include <machine/cpu.h>
 #include <machine/setjmp.h>
 
+#include <vps/vps.h>
+
 /*
  * Exported global variables
  */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/ddb/db_ps.c head/sys/ddb/db_ps.c
--- clean-head/sys/ddb/db_ps.c	2013-06-26 09:37:39.000000000 +0200
+++ head/sys/ddb/db_ps.c	2013-06-24 14:21:40.000000000 +0200
@@ -42,6 +42,8 @@ __FBSDID("$FreeBSD: head/sys/ddb/db_ps.c
 #include <vm/vm_param.h>
 #include <vm/pmap.h>
 
+#include <vps/vps.h>
+
 #include <ddb/ddb.h>
 
 static void	dumpthread(volatile struct proc *p, volatile struct thread *td,
@@ -84,10 +86,10 @@ db_ps(db_expr_t addr, boolean_t hasaddr,
 	char state[9];
 	int np, rflag, sflag, dflag, lflag, wflag;
 
-	np = nprocs;
+	np = V_nprocs;
 
-	if (!LIST_EMPTY(&allproc))
-		p = LIST_FIRST(&allproc);
+	if (!LIST_EMPTY(&V_allproc))
+		p = LIST_FIRST(&V_allproc);
 	else
 		p = &proc0;
 
@@ -210,7 +212,7 @@ db_ps(db_expr_t addr, boolean_t hasaddr,
 
 		p = LIST_NEXT(p, p_list);
 		if (p == NULL && np > 0)
-			p = LIST_FIRST(&zombproc);
+			p = LIST_FIRST(&V_zombproc);
     	}
 }
 
@@ -374,6 +376,11 @@ DB_SHOW_COMMAND(thread, db_show_thread)
 		    td->td_wchan);
 	db_printf(" priority: %d\n", td->td_priority);
 	db_printf(" container lock: %s (%p)\n", lock->lo_name, lock);
+#ifdef VPS
+	db_printf(" td_vps: %p\n", td->td_vps);
+	if (td->td_ucred)
+		db_printf(" td_ucred->cr_vps: %p\n", td->td_ucred->cr_vps);
+#endif
 }
 
 DB_SHOW_COMMAND(proc, db_show_proc)
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/ddb/db_thread.c head/sys/ddb/db_thread.c
--- clean-head/sys/ddb/db_thread.c	2013-06-26 09:37:39.000000000 +0200
+++ head/sys/ddb/db_thread.c	2013-06-24 14:21:40.000000000 +0200
@@ -38,6 +38,8 @@ __FBSDID("$FreeBSD: head/sys/ddb/db_thre
 #include <ddb/db_command.h>
 #include <ddb/db_sym.h>
 
+#include <vps/vps.h>
+
 void
 db_print_thread(void)
 {
@@ -137,7 +139,7 @@ db_lookup_thread(db_expr_t addr, boolean
 			if (p->p_pid == decaddr)
 				return (FIRST_THREAD_IN_PROC(p));
 		}
-		LIST_FOREACH(p, &zombproc, p_list) {
+		LIST_FOREACH(p, &V_zombproc, p_list) {
 			if (p->p_pid == decaddr)
 				return (FIRST_THREAD_IN_PROC(p));
 		}
@@ -163,7 +165,7 @@ db_lookup_proc(db_expr_t addr)
 			if (p->p_pid == decaddr)
 				return (p);
 		}
-		LIST_FOREACH(p, &zombproc, p_list) {
+		LIST_FOREACH(p, &V_zombproc, p_list) {
 			if (p->p_pid == decaddr)
 				return (p);
 		}
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/dev/firewire/firewire.c head/sys/dev/firewire/firewire.c
--- clean-head/sys/dev/firewire/firewire.c	2013-06-26 09:36:57.000000000 +0200
+++ head/sys/dev/firewire/firewire.c	2013-06-24 14:21:02.000000000 +0200
@@ -45,6 +45,7 @@ __FBSDID("$FreeBSD: head/sys/dev/firewir
 #include <sys/malloc.h>
 #include <sys/conf.h>
 #include <sys/sysctl.h>
+#include <sys/proc.h>
 #include <sys/kthread.h>
 
 #include <sys/kdb.h>
@@ -56,6 +57,8 @@ __FBSDID("$FreeBSD: head/sys/dev/firewir
 #include <sys/bus.h>		/* used by smbus and newbus */
 #include <machine/bus.h>
 
+#include <vps/vps.h>
+
 #ifdef __DragonFly__
 #include "firewire.h"
 #include "firewirereg.h"
@@ -724,9 +727,9 @@ fw_reset_crom(struct firewire_comm *fc)
 	crom_add_simple_text(src, root, &buf->vendor, "FreeBSD Project");
 	crom_add_entry(root, CSRKEY_HW, __FreeBSD_version);
 #endif
-	mtx_lock(&prison0.pr_mtx);
-	crom_add_simple_text(src, root, &buf->hw, prison0.pr_hostname);
-	mtx_unlock(&prison0.pr_mtx);
+	mtx_lock(&V_prison0->pr_mtx);
+	crom_add_simple_text(src, root, &buf->hw, V_prison0->pr_hostname);
+	mtx_unlock(&V_prison0->pr_mtx);
 }
 
 /*
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/dev/hwpmc/hwpmc_mod.c head/sys/dev/hwpmc/hwpmc_mod.c
--- clean-head/sys/dev/hwpmc/hwpmc_mod.c	2013-06-26 09:36:30.000000000 +0200
+++ head/sys/dev/hwpmc/hwpmc_mod.c	2013-06-24 14:21:05.000000000 +0200
@@ -62,6 +62,8 @@ __FBSDID("$FreeBSD: head/sys/dev/hwpmc/h
 
 #include <sys/linker.h>		/* needs to be after <sys/malloc.h> */
 
+#include <vps/vps.h>
+
 #include <machine/atomic.h>
 #include <machine/md_var.h>
 
@@ -1057,7 +1059,7 @@ pmc_attach_process(struct proc *p, struc
 	 * this PMC.
 	 */
 
-	sx_slock(&proctree_lock);
+	sx_slock(&V_proctree_lock);
 
 	top = p;
 
@@ -1081,7 +1083,7 @@ pmc_attach_process(struct proc *p, struc
 		(void) pmc_detach_process(top, pm);
 
  done:
-	sx_sunlock(&proctree_lock);
+	sx_sunlock(&V_proctree_lock);
 	return error;
 }
 
@@ -1166,7 +1168,7 @@ pmc_detach_process(struct proc *p, struc
 	 * partially attached proc tree.
 	 */
 
-	sx_slock(&proctree_lock);
+	sx_slock(&V_proctree_lock);
 
 	top = p;
 
@@ -1187,7 +1189,7 @@ pmc_detach_process(struct proc *p, struc
 	}
 
  done:
-	sx_sunlock(&proctree_lock);
+	sx_sunlock(&V_proctree_lock);
 
 	if (LIST_EMPTY(&pm->pm_targets))
 		pm->pm_flags &= ~PMC_F_ATTACH_DONE;
@@ -1798,7 +1800,7 @@ pmc_log_all_process_mappings(struct pmc_
 
 	PROC_UNLOCK(p);
 
-	sx_slock(&proctree_lock);
+	sx_slock(&V_proctree_lock);
 
 	top = p;
 
@@ -1817,7 +1819,7 @@ pmc_log_all_process_mappings(struct pmc_
 		}
 	}
  done:
-	sx_sunlock(&proctree_lock);
+	sx_sunlock(&V_proctree_lock);
 }
 
 /*
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/dev/syscons/daemon/daemon_saver.c head/sys/dev/syscons/daemon/daemon_saver.c
--- clean-head/sys/dev/syscons/daemon/daemon_saver.c	2013-06-26 09:37:23.000000000 +0200
+++ head/sys/dev/syscons/daemon/daemon_saver.c	2013-06-24 14:21:15.000000000 +0200
@@ -37,6 +37,9 @@
 #include <sys/sysctl.h>
 #include <sys/consio.h>
 #include <sys/fbio.h>
+#include <sys/proc.h>
+
+#include <vps/vps.h>
 
 #include <machine/pc/display.h>
 
@@ -353,23 +356,23 @@ daemon_init(video_adapter_t *adp)
 {
 	size_t hostlen;
 
-	mtx_lock(&prison0.pr_mtx);
+	mtx_lock(&V_prison0->pr_mtx);
 	for (;;) {
-		hostlen = strlen(prison0.pr_hostname);
-		mtx_unlock(&prison0.pr_mtx);
+		hostlen = strlen(V_prison0->pr_hostname);
+		mtx_unlock(&V_prison0->pr_mtx);
 	
 		messagelen = hostlen + 3 + strlen(ostype) + 1 +
 		    strlen(osrelease);
 		message = malloc(messagelen + 1, M_DEVBUF, M_WAITOK);
-		mtx_lock(&prison0.pr_mtx);
-		if (hostlen < strlen(prison0.pr_hostname)) {
+		mtx_lock(&V_prison0->pr_mtx);
+		if (hostlen < strlen(V_prison0->pr_hostname)) {
 			free(message, M_DEVBUF);
 			continue;
 		}
 		break;
 	}
-	sprintf(message, "%s - %s %s", prison0.pr_hostname, ostype, osrelease);
-	mtx_unlock(&prison0.pr_mtx);
+	sprintf(message, "%s - %s %s", V_prison0->pr_hostname, ostype, osrelease);
+	mtx_unlock(&V_prison0->pr_mtx);
 	blanked = 0;
 	switch (adp->va_mode) {
 	case M_PC98_80x25:
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/dev/syscons/syscons.c head/sys/dev/syscons/syscons.c
--- clean-head/sys/dev/syscons/syscons.c	2013-06-26 09:37:23.000000000 +0200
+++ head/sys/dev/syscons/syscons.c	2013-06-24 14:21:15.000000000 +0200
@@ -61,6 +61,9 @@ __FBSDID("$FreeBSD: head/sys/dev/syscons
 #include <sys/tty.h>
 #include <sys/power.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #include <machine/clock.h>
 #if defined(__arm__) || defined(__mips__) || \
 	defined(__powerpc__) || defined(__sparc64__)
@@ -360,7 +363,11 @@ sc_alloc_tty(int index, int devnum)
 	tp = tty_alloc_mutex(&sc_ttydevsw, stc, &Giant);
 
 	/* Create device node. */
+#ifdef VPS
+	tty_makedev(tp, vps0->vps_ucred, "v%r", devnum);
+#else
 	tty_makedev(tp, NULL, "v%r", devnum);
+#endif
 
 	return (tp);
 }
@@ -565,8 +572,13 @@ sc_attach_unit(int unit, int flags)
 	 */
     }
 
+#ifdef VPS
+    dev = make_dev_cred(&consolectl_devsw, 0, vps0->vps_ucred,
+	UID_ROOT, GID_WHEEL, 0600, "consolectl");
+#else
     dev = make_dev(&consolectl_devsw, 0, UID_ROOT, GID_WHEEL, 0600,
         "consolectl");
+#endif
     dev->si_drv1 = sc->dev[0];
 
     return 0;
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/devfs/devfs.h head/sys/fs/devfs/devfs.h
--- clean-head/sys/fs/devfs/devfs.h	2013-06-26 09:38:35.000000000 +0200
+++ head/sys/fs/devfs/devfs.h	2013-06-24 14:20:41.000000000 +0200
@@ -161,6 +161,10 @@ struct devfs_mount {
 	int			dm_holdcnt;
 	struct sx		dm_lock;
 	devfs_rsnum		dm_ruleset;
+#ifdef VPS
+	struct vps		*dm_vps;
+	int			dm_vps_rsnum;
+#endif
 };
 
 #define DEVFS_ROOTINO 2
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/devfs/devfs_devs.c head/sys/fs/devfs/devfs_devs.c
--- clean-head/sys/fs/devfs/devfs_devs.c	2013-06-26 09:38:35.000000000 +0200
+++ head/sys/fs/devfs/devfs_devs.c	2013-06-24 14:20:41.000000000 +0200
@@ -43,6 +43,9 @@
 
 #include <sys/kdb.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #include <fs/devfs/devfs.h>
 #include <fs/devfs/devfs_int.h>
 
@@ -145,12 +148,23 @@ int
 devfs_dev_exists(const char *name)
 {
 	struct cdev_priv *cdp;
+#ifdef VPS
+	struct vps *vps = curthread->td_vps;
+#endif
 
 	mtx_assert(&devmtx, MA_OWNED);
 
 	TAILQ_FOREACH(cdp, &cdevp_list, cdp_list) {
 		if ((cdp->cdp_flags & CDP_ACTIVE) == 0)
 			continue;
+#ifdef VPS
+		if ((cdp->cdp_c.si_cred && cdp->cdp_c.si_cred->cr_vps != vps))
+			/* 
+			 * This device does not belong to the
+			 * vps instance that is asking.
+			 */
+			continue;
+#endif
 		if (devfs_pathpath(cdp->cdp_c.si_name, name) != 0)
 			return (1);
 		if (devfs_pathpath(name, cdp->cdp_c.si_name) != 0)
@@ -546,6 +560,10 @@ devfs_populate_loop(struct devfs_mount *
 			continue;
 		}
 
+#ifdef VPS
+		if (vps_devfs_whiteout_cb(dm, cdp))
+			continue;
+#endif /* VPS */
 
 		cdp->cdp_inuse++;
 		dev_unlock();
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/devfs/devfs_vfsops.c head/sys/fs/devfs/devfs_vfsops.c
--- clean-head/sys/fs/devfs/devfs_vfsops.c	2013-06-26 09:38:35.000000000 +0200
+++ head/sys/fs/devfs/devfs_vfsops.c	2013-06-24 14:20:41.000000000 +0200
@@ -46,6 +46,9 @@
 #include <sys/limits.h>
 #include <sys/jail.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #include <fs/devfs/devfs.h>
 
 static struct unrhdr	*devfs_unr;
@@ -142,6 +145,17 @@ devfs_mount(struct mount *mp)
 
 	fmp->dm_rootdir = devfs_vmkdir(fmp, NULL, 0, NULL, DEVFS_ROOTINO);
 
+#ifdef VPS
+	/* Get number of an apropriate ruleset. */
+	error = vps_devfs_mount_cb(fmp, &rsnum);
+	if (error != 0) {
+		sx_destroy(&fmp->dm_lock);
+		free_unr(devfs_unr, fmp->dm_idx);
+		free(fmp, M_DEVFS);
+		return (error);
+	}
+#endif /* VPS */
+
 	error = devfs_root(mp, LK_EXCLUSIVE, &rvp);
 	if (error) {
 		sx_destroy(&fmp->dm_lock);
@@ -195,6 +209,9 @@ devfs_unmount(struct mount *mp, int mntf
 	idx = fmp->dm_idx;
 	sx_xunlock(&fmp->dm_lock);
 	free_unr(devfs_unr, idx);
+#ifdef VPS
+	(void)vps_devfs_unmount_cb(fmp);
+#endif /* VPS */
 	if (hold == 0)
 		devfs_unmount_final(fmp);
 	return 0;
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/devfs/devfs_vnops.c head/sys/fs/devfs/devfs_vnops.c
--- clean-head/sys/fs/devfs/devfs_vnops.c	2013-06-26 09:38:35.000000000 +0200
+++ head/sys/fs/devfs/devfs_vnops.c	2013-06-24 14:20:41.000000000 +0200
@@ -62,6 +62,9 @@
 #include <sys/unistd.h>
 #include <sys/vnode.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 static struct vop_vector devfs_vnodeops;
 static struct vop_vector devfs_specops;
 static struct fileops devfs_ops_f;
@@ -546,7 +549,7 @@ devfs_close(struct vop_close_args *ap)
 	 * plus the session), release the reference from the session.
 	 */
 	oldvp = NULL;
-	sx_xlock(&proctree_lock);
+	sx_xlock(&V_proctree_lock);
 	if (td && vp == td->td_proc->p_session->s_ttyvp) {
 		SESS_LOCK(td->td_proc->p_session);
 		VI_LOCK(vp);
@@ -558,7 +561,7 @@ devfs_close(struct vop_close_args *ap)
 		VI_UNLOCK(vp);
 		SESS_UNLOCK(td->td_proc->p_session);
 	}
-	sx_xunlock(&proctree_lock);
+	sx_xunlock(&V_proctree_lock);
 	if (oldvp != NULL)
 		vrele(oldvp);
 	/*
@@ -684,12 +687,12 @@ devfs_getattr(struct vop_getattr_args *a
 	vap->va_blocksize = DEV_BSIZE;
 	vap->va_type = vp->v_type;
 
-#define fix(aa)							\
-	do {							\
-		if ((aa).tv_sec <= 3600) {			\
-			(aa).tv_sec = boottime.tv_sec;		\
-			(aa).tv_nsec = boottime.tv_usec * 1000; \
-		}						\
+#define fix(aa)								\
+	do {								\
+		if ((aa).tv_sec <= 3600) {				\
+			(aa).tv_sec = G_boottime.tv_sec;		\
+			(aa).tv_nsec = G_boottime.tv_usec * 1000; 	\
+		}							\
 	} while (0)
 
 	if (vp->v_type != VCHR)  {
@@ -763,9 +766,9 @@ devfs_ioctl_f(struct file *fp, u_long co
 		vp = fp->f_vnode;
 
 		/* Do nothing if reassigning same control tty */
-		sx_slock(&proctree_lock);
+		sx_slock(&V_proctree_lock);
 		if (td->td_proc->p_session->s_ttyvp == vp) {
-			sx_sunlock(&proctree_lock);
+			sx_sunlock(&V_proctree_lock);
 			return (0);
 		}
 
@@ -776,7 +779,7 @@ devfs_ioctl_f(struct file *fp, u_long co
 		td->td_proc->p_session->s_ttydp = cdev2priv(dev);
 		SESS_UNLOCK(td->td_proc->p_session);
 
-		sx_sunlock(&proctree_lock);
+		sx_sunlock(&V_proctree_lock);
 
 		/* Get rid of reference to old control tty */
 		if (vpold)
@@ -1364,6 +1367,10 @@ devfs_remove(struct vop_remove_args *ap)
  * as well so that we create a new one next time around.
  *
  */
+#ifdef VPS
+extern struct cdev *dev_console;
+#endif
+
 static int
 devfs_revoke(struct vop_revoke_args *ap)
 {
@@ -1377,6 +1384,16 @@ devfs_revoke(struct vop_revoke_args *ap)
 
 	dev = vp->v_rdev;
 	cdp = cdev2priv(dev);
+
+#ifdef VPS
+	if (dev != dev_console && !strcmp(dev->si_name, "console")) {
+		/* 
+		 * This is a virtual console device, and we don't
+		 * like being revoked.
+		 */
+	   return (EPERM);
+	}
+#endif
  
 	dev_lock();
 	cdp->cdp_inuse++;
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/fdescfs/fdesc_vnops.c head/sys/fs/fdescfs/fdesc_vnops.c
--- clean-head/sys/fs/fdescfs/fdesc_vnops.c	2013-06-26 09:38:32.000000000 +0200
+++ head/sys/fs/fdescfs/fdesc_vnops.c	2013-06-24 14:20:41.000000000 +0200
@@ -55,6 +55,8 @@
 #include <sys/stat.h>
 #include <sys/vnode.h>
 
+#include <vps/vps.h>
+
 #include <fs/fdescfs/fdesc.h>
 
 #define	NFDCACHE 4
@@ -399,7 +401,7 @@ fdesc_getattr(ap)
 	vap->va_uid = 0;
 	vap->va_gid = 0;
 	vap->va_blocksize = DEV_BSIZE;
-	vap->va_atime.tv_sec = boottime.tv_sec;
+	vap->va_atime.tv_sec = G_boottime.tv_sec;
 	vap->va_atime.tv_nsec = 0;
 	vap->va_mtime = vap->va_atime;
 	vap->va_ctime = vap->va_mtime;
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/nfs/nfsport.h head/sys/fs/nfs/nfsport.h
--- clean-head/sys/fs/nfs/nfsport.h	2013-06-26 09:38:34.000000000 +0200
+++ head/sys/fs/nfs/nfsport.h	2013-06-24 14:20:40.000000000 +0200
@@ -99,6 +99,8 @@
 #include <rpc/rpc.h>
 #include <rpc/rpcsec_gss.h>
 
+#include <vps/vps.h>
+
 /*
  * For Darwin, these functions should be "static" when built in a kext.
  * (This is always defined as nil otherwise.)
@@ -636,8 +638,8 @@ void nfsrvd_rcv(struct socket *, void *,
 #define	NFSUNLOCKMNT(m)		mtx_unlock(&((m)->nm_mtx))
 #define	NFSLOCKREQUEST(r)	mtx_lock(&((r)->r_mtx))
 #define	NFSUNLOCKREQUEST(r)	mtx_unlock(&((r)->r_mtx))
-#define	NFSPROCLISTLOCK()	sx_slock(&allproc_lock)
-#define	NFSPROCLISTUNLOCK()	sx_sunlock(&allproc_lock)
+#define	NFSPROCLISTLOCK()	sx_slock(&V_allproc_lock)
+#define	NFSPROCLISTUNLOCK()	sx_sunlock(&V_allproc_lock)
 #define	NFSLOCKSOCKREQ(r)	mtx_lock(&((r)->nr_mtx))
 #define	NFSUNLOCKSOCKREQ(r)	mtx_unlock(&((r)->nr_mtx))
 #define	NFSLOCKDS(d)		mtx_lock(&((d)->nfsclds_mtx))
@@ -869,7 +871,7 @@ int newnfs_realign(struct mbuf **, int);
 /*
  * Set boottime.
  */
-#define	NFSSETBOOTTIME(b)	((b) = boottime)
+#define	NFSSETBOOTTIME(b)	((b) = G_boottime)
 
 /*
  * The size of directory blocks in the buffer cache.
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/nfsclient/nfs_clvfsops.c head/sys/fs/nfsclient/nfs_clvfsops.c
--- clean-head/sys/fs/nfsclient/nfs_clvfsops.c	2013-06-26 09:38:34.000000000 +0200
+++ head/sys/fs/nfsclient/nfs_clvfsops.c	2013-06-24 14:20:40.000000000 +0200
@@ -496,10 +496,10 @@ nfs_mountroot(struct mount *mp)
 	 * set hostname here and then let the "/etc/rc.xxx" files
 	 * mount the right /var based upon its preset value.
 	 */
-	mtx_lock(&prison0.pr_mtx);
-	strlcpy(prison0.pr_hostname, nd->my_hostnam,
-	    sizeof(prison0.pr_hostname));
-	mtx_unlock(&prison0.pr_mtx);
+	mtx_lock(&V_prison0->pr_mtx);
+	strlcpy(V_prison0->pr_hostname, nd->my_hostnam,
+	    sizeof(V_prison0->pr_hostname));
+	mtx_unlock(&V_prison0->pr_mtx);
 	inittodr(ntohl(nd->root_time));
 	return (0);
 }
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/procfs/procfs_ctl.c head/sys/fs/procfs/procfs_ctl.c
--- clean-head/sys/fs/procfs/procfs_ctl.c	2013-06-26 09:38:35.000000000 +0200
+++ head/sys/fs/procfs/procfs_ctl.c	2013-06-24 14:20:40.000000000 +0200
@@ -47,6 +47,7 @@
 #include <sys/signalvar.h>
 #include <sys/sx.h>
 #include <sys/uio.h>
+#include <vps/vps.h>
 
 #include <fs/pseudofs/pseudofs.h>
 #include <fs/procfs/procfs.h>
@@ -117,7 +118,7 @@ procfs_control(struct thread *td, struct
 	 * by the calling process.
 	 */
 	if (op == PROCFS_CTL_ATTACH) {
-		sx_xlock(&proctree_lock);
+		sx_xlock(&V_proctree_lock);
 		PROC_LOCK(p);
 		if ((error = p_candebug(td, p)) != 0)
 			goto out;
@@ -150,7 +151,7 @@ procfs_control(struct thread *td, struct
 		kern_psignal(p, SIGSTOP);
 out:
 		PROC_UNLOCK(p);
-		sx_xunlock(&proctree_lock);
+		sx_xunlock(&V_proctree_lock);
 		return (error);
 	}
 
@@ -222,7 +223,7 @@ out:
 		PROC_UNLOCK(p);
 
 		/* give process back to original parent */
-		sx_xlock(&proctree_lock);
+		sx_xlock(&V_proctree_lock);
 		if (p->p_oppid != p->p_pptr->p_pid) {
 			struct proc *pp;
 
@@ -236,7 +237,7 @@ out:
 			PROC_LOCK(p);
 		p->p_oppid = 0;
 		p->p_flag &= ~P_WAITED;	/* XXX ? */
-		sx_xunlock(&proctree_lock);
+		sx_xunlock(&V_proctree_lock);
 
 		wakeup(td->td_proc);	/* XXX for CTL_WAIT below ? */
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/procfs/procfs_status.c head/sys/fs/procfs/procfs_status.c
--- clean-head/sys/fs/procfs/procfs_status.c	2013-06-26 09:38:35.000000000 +0200
+++ head/sys/fs/procfs/procfs_status.c	2013-06-24 14:20:40.000000000 +0200
@@ -53,6 +53,9 @@
 #include <sys/sysent.h>
 #include <sys/tty.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #include <vm/vm.h>
 #include <vm/pmap.h>
 #include <vm/vm_param.h>
@@ -129,7 +132,7 @@ procfs_doprocstatus(PFS_FILL_ARGS)
 		calcru(p, &ut, &st);
 		PROC_SUNLOCK(p);
 		start = p->p_stats->p_start;
-		timevaladd(&start, &boottime);
+		timevaladd(&start, &G_boottime);
 		sbuf_printf(sb, " %jd,%ld %jd,%ld %jd,%ld",
 		    (intmax_t)start.tv_sec, start.tv_usec,
 		    (intmax_t)ut.tv_sec, ut.tv_usec,
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/pseudofs/pseudofs_vnops.c head/sys/fs/pseudofs/pseudofs_vnops.c
--- clean-head/sys/fs/pseudofs/pseudofs_vnops.c	2013-06-26 09:38:34.000000000 +0200
+++ head/sys/fs/pseudofs/pseudofs_vnops.c	2013-06-24 14:20:40.000000000 +0200
@@ -49,6 +49,8 @@ __FBSDID("$FreeBSD: head/sys/fs/pseudofs
 #include <sys/sysctl.h>
 #include <sys/vnode.h>
 
+#include <vps/vps.h>
+
 #include <fs/pseudofs/pseudofs.h>
 #include <fs/pseudofs/pseudofs_internal.h>
 
@@ -704,7 +706,7 @@ pfs_iterate(struct thread *td, struct pr
 {
 	int visible;
 
-	sx_assert(&allproc_lock, SX_SLOCKED);
+	sx_assert(&V_allproc_lock, SX_SLOCKED);
 	pfs_assert_owned(pd);
  again:
 	if (*pn == NULL) {
@@ -717,7 +719,7 @@ pfs_iterate(struct thread *td, struct pr
 	if (*pn != NULL && (*pn)->pn_type == pfstype_procdir) {
 		/* next process */
 		if (*p == NULL)
-			*p = LIST_FIRST(&allproc);
+			*p = LIST_FIRST(&V_allproc);
 		else
 			*p = LIST_NEXT(*p, p_list);
 		/* out of processes: next node */
@@ -790,12 +792,12 @@ pfs_readdir(struct vop_readdir_args *va)
 	if (resid == 0)
 		PFS_RETURN (0);
 
-	sx_slock(&allproc_lock);
+	sx_slock(&V_allproc_lock);
 	pfs_lock(pd);
 
         /* check if the directory is visible to the caller */
         if (!pfs_visible(curthread, pd, pid, &proc)) {
-		sx_sunlock(&allproc_lock);
+		sx_sunlock(&V_allproc_lock);
 		pfs_unlock(pd);
                 PFS_RETURN (ENOENT);
 	}
@@ -809,7 +811,7 @@ pfs_readdir(struct vop_readdir_args *va)
 			if (proc != NULL)
 				PROC_UNLOCK(proc);
 			pfs_unlock(pd);
-			sx_sunlock(&allproc_lock);
+			sx_sunlock(&V_allproc_lock);
 			PFS_RETURN (0);
 		}
 	}
@@ -859,7 +861,7 @@ pfs_readdir(struct vop_readdir_args *va)
 	if (proc != NULL)
 		PROC_UNLOCK(proc);
 	pfs_unlock(pd);
-	sx_sunlock(&allproc_lock);
+	sx_sunlock(&V_allproc_lock);
 	i = 0;
 	STAILQ_FOREACH_SAFE(pfsent, &lst, link, pfsent2) {
 		if (error == 0)
